class Event(object):
    """This is the abstract base class for the events dispatched during \
       a tetris game."""

    def __init__(self, source):
        object.__init__(self)
        self._source = source

    @property
    def source(self):
        """The object that dispatches this event object."""
        return self._source


class BoardEvent(Event):
    pass

class ScoreEvent(Event):
    
    def __init__(self, score, lines_cleared):
        self._score = score
        self._lines_cleared = lines_cleared

    @property
    def score(self):
        return self._score

    @property
    def lines_cleared(self):
        return self._lines_cleared

class GameEvent(Event):

    END = 0
    START = 1
    
    def __init__(self, state):
        self._state = state

    @property 
    def state(self):
        return self._state
